package com.afp.ordermanagement.model;

import lombok.Data;

import java.util.Objects;

@Data
public class Item {

    private String id;
    private int stock;
    private double price;
    private int sku;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Item)) return false;
        Item item = (Item) o;
        return getStock() == item.getStock() && Double.compare(item.getPrice(), getPrice()) == 0 && getSku() == item.getSku() && getId().equals(item.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId(), getStock(), getPrice(), getSku());
    }

    @Override
    public String toString() {
        return "Item{" +
                "id='" + id + '\'' +
                ", stock=" + stock +
                ", price=" + price +
                ", sku=" + sku +
                '}';
    }
}
