package com.afp.ordermanagement.service;

import com.afp.ordermanagement.model.Order;
import com.afp.ordermanagement.repository.OrderRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class OrderService {

    @Autowired
    OrderRepository orderRepository;

    public Mono<Order> createOrder(Order newOrder){
        return orderRepository.save(newOrder);
    }

    public Flux<Order> getAllOrders(){
        return orderRepository.findAll();
    }

    public Flux<Order> getAllOrdersByUserId(String userId){
        return orderRepository.findByUserId(userId);
    }

    public Mono<Order> updateOrderByOrderId(String orderId, Order newOrder){
        return orderRepository.findById(orderId)
                .flatMap(existingOrder -> {
                    existingOrder.setAddress(newOrder.getAddress());
                    existingOrder.setEmailAddress(newOrder.getEmailAddress());
                    existingOrder.setTrackingCode(newOrder.getTrackingCode());
                    existingOrder.setItems(newOrder.getItems());
                    existingOrder.setStatus(newOrder.getStatus());
                    return orderRepository.save(existingOrder);
                });
    }
}
